/**
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


#include "SWGCandleDate.h"

#include "SWGHelpers.h"

#include <QJsonDocument>
#include <QJsonArray>
#include <QObject>
#include <QDebug>

namespace Swagger {

SWGCandleDate::SWGCandleDate(QString json) {
    init();
    this->fromJson(json);
}

SWGCandleDate::SWGCandleDate() {
    init();
}

SWGCandleDate::~SWGCandleDate() {
    this->cleanup();
}

void
SWGCandleDate::init() {
    market = new QString("");
    m_market_isSet = false;
    candle_date_time_utc = new QString("");
    m_candle_date_time_utc_isSet = false;
    candle_date_time_kst = new QString("");
    m_candle_date_time_kst_isSet = false;
    opening_price = 0.0;
    m_opening_price_isSet = false;
    high_price = 0.0;
    m_high_price_isSet = false;
    low_price = 0.0;
    m_low_price_isSet = false;
    trade_price = 0.0;
    m_trade_price_isSet = false;
    timestamp = 0.0;
    m_timestamp_isSet = false;
    candle_acc_trade_price = 0.0;
    m_candle_acc_trade_price_isSet = false;
    candle_acc_trade_volume = 0.0;
    m_candle_acc_trade_volume_isSet = false;
    first_day_of_period = new QString("");
    m_first_day_of_period_isSet = false;
}

void
SWGCandleDate::cleanup() {
    if(market != nullptr) { 
        delete market;
    }
    if(candle_date_time_utc != nullptr) { 
        delete candle_date_time_utc;
    }
    if(candle_date_time_kst != nullptr) { 
        delete candle_date_time_kst;
    }




    if(timestamp != nullptr) { 
        delete timestamp;
    }


    if(first_day_of_period != nullptr) { 
        delete first_day_of_period;
    }
}

SWGCandleDate*
SWGCandleDate::fromJson(QString json) {
    QByteArray array (json.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
    return this;
}

void
SWGCandleDate::fromJsonObject(QJsonObject pJson) {
    ::Swagger::setValue(&market, pJson["market"], "QString", "QString");
    
    ::Swagger::setValue(&candle_date_time_utc, pJson["candle_date_time_utc"], "QString", "QString");
    
    ::Swagger::setValue(&candle_date_time_kst, pJson["candle_date_time_kst"], "QString", "QString");
    
    ::Swagger::setValue(&opening_price, pJson["opening_price"], "double", "");
    
    ::Swagger::setValue(&high_price, pJson["high_price"], "double", "");
    
    ::Swagger::setValue(&low_price, pJson["low_price"], "double", "");
    
    ::Swagger::setValue(&trade_price, pJson["trade_price"], "double", "");
    
    ::Swagger::setValue(&timestamp, pJson["timestamp"], "SWGNumber", "SWGNumber");
    
    ::Swagger::setValue(&candle_acc_trade_price, pJson["candle_acc_trade_price"], "double", "");
    
    ::Swagger::setValue(&candle_acc_trade_volume, pJson["candle_acc_trade_volume"], "double", "");
    
    ::Swagger::setValue(&first_day_of_period, pJson["first_day_of_period"], "QString", "QString");
    
}

QString
SWGCandleDate::asJson ()
{
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject
SWGCandleDate::asJsonObject() {
    QJsonObject obj;
    if(market != nullptr && *market != QString("")){
        toJsonValue(QString("market"), market, obj, QString("QString"));
    }
    if(candle_date_time_utc != nullptr && *candle_date_time_utc != QString("")){
        toJsonValue(QString("candle_date_time_utc"), candle_date_time_utc, obj, QString("QString"));
    }
    if(candle_date_time_kst != nullptr && *candle_date_time_kst != QString("")){
        toJsonValue(QString("candle_date_time_kst"), candle_date_time_kst, obj, QString("QString"));
    }
    if(m_opening_price_isSet){
        obj.insert("opening_price", QJsonValue(opening_price));
    }
    if(m_high_price_isSet){
        obj.insert("high_price", QJsonValue(high_price));
    }
    if(m_low_price_isSet){
        obj.insert("low_price", QJsonValue(low_price));
    }
    if(m_trade_price_isSet){
        obj.insert("trade_price", QJsonValue(trade_price));
    }
    if((timestamp != nullptr) && (timestamp->isSet())){
        toJsonValue(QString("timestamp"), timestamp, obj, QString("SWGNumber"));
    }
    if(m_candle_acc_trade_price_isSet){
        obj.insert("candle_acc_trade_price", QJsonValue(candle_acc_trade_price));
    }
    if(m_candle_acc_trade_volume_isSet){
        obj.insert("candle_acc_trade_volume", QJsonValue(candle_acc_trade_volume));
    }
    if(first_day_of_period != nullptr && *first_day_of_period != QString("")){
        toJsonValue(QString("first_day_of_period"), first_day_of_period, obj, QString("QString"));
    }

    return obj;
}

QString*
SWGCandleDate::getMarket() {
    return market;
}
void
SWGCandleDate::setMarket(QString* market) {
    this->market = market;
    this->m_market_isSet = true;
}

QString*
SWGCandleDate::getCandleDateTimeUtc() {
    return candle_date_time_utc;
}
void
SWGCandleDate::setCandleDateTimeUtc(QString* candle_date_time_utc) {
    this->candle_date_time_utc = candle_date_time_utc;
    this->m_candle_date_time_utc_isSet = true;
}

QString*
SWGCandleDate::getCandleDateTimeKst() {
    return candle_date_time_kst;
}
void
SWGCandleDate::setCandleDateTimeKst(QString* candle_date_time_kst) {
    this->candle_date_time_kst = candle_date_time_kst;
    this->m_candle_date_time_kst_isSet = true;
}

double
SWGCandleDate::getOpeningPrice() {
    return opening_price;
}
void
SWGCandleDate::setOpeningPrice(double opening_price) {
    this->opening_price = opening_price;
    this->m_opening_price_isSet = true;
}

double
SWGCandleDate::getHighPrice() {
    return high_price;
}
void
SWGCandleDate::setHighPrice(double high_price) {
    this->high_price = high_price;
    this->m_high_price_isSet = true;
}

double
SWGCandleDate::getLowPrice() {
    return low_price;
}
void
SWGCandleDate::setLowPrice(double low_price) {
    this->low_price = low_price;
    this->m_low_price_isSet = true;
}

double
SWGCandleDate::getTradePrice() {
    return trade_price;
}
void
SWGCandleDate::setTradePrice(double trade_price) {
    this->trade_price = trade_price;
    this->m_trade_price_isSet = true;
}

SWGNumber*
SWGCandleDate::getTimestamp() {
    return timestamp;
}
void
SWGCandleDate::setTimestamp(SWGNumber* timestamp) {
    this->timestamp = timestamp;
    this->m_timestamp_isSet = true;
}

double
SWGCandleDate::getCandleAccTradePrice() {
    return candle_acc_trade_price;
}
void
SWGCandleDate::setCandleAccTradePrice(double candle_acc_trade_price) {
    this->candle_acc_trade_price = candle_acc_trade_price;
    this->m_candle_acc_trade_price_isSet = true;
}

double
SWGCandleDate::getCandleAccTradeVolume() {
    return candle_acc_trade_volume;
}
void
SWGCandleDate::setCandleAccTradeVolume(double candle_acc_trade_volume) {
    this->candle_acc_trade_volume = candle_acc_trade_volume;
    this->m_candle_acc_trade_volume_isSet = true;
}

QString*
SWGCandleDate::getFirstDayOfPeriod() {
    return first_day_of_period;
}
void
SWGCandleDate::setFirstDayOfPeriod(QString* first_day_of_period) {
    this->first_day_of_period = first_day_of_period;
    this->m_first_day_of_period_isSet = true;
}


bool
SWGCandleDate::isSet(){
    bool isObjectUpdated = false;
    do{
        if(market != nullptr && *market != QString("")){ isObjectUpdated = true; break;}
        if(candle_date_time_utc != nullptr && *candle_date_time_utc != QString("")){ isObjectUpdated = true; break;}
        if(candle_date_time_kst != nullptr && *candle_date_time_kst != QString("")){ isObjectUpdated = true; break;}
        if(m_opening_price_isSet){ isObjectUpdated = true; break;}
        if(m_high_price_isSet){ isObjectUpdated = true; break;}
        if(m_low_price_isSet){ isObjectUpdated = true; break;}
        if(m_trade_price_isSet){ isObjectUpdated = true; break;}
        if(timestamp != nullptr && timestamp->isSet()){ isObjectUpdated = true; break;}
        if(m_candle_acc_trade_price_isSet){ isObjectUpdated = true; break;}
        if(m_candle_acc_trade_volume_isSet){ isObjectUpdated = true; break;}
        if(first_day_of_period != nullptr && *first_day_of_period != QString("")){ isObjectUpdated = true; break;}
    }while(false);
    return isObjectUpdated;
}
}

