# IO.Swagger - the C# library for the Upbit Open API

## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 

This C# SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- SDK version: 1.0.0
- Build package: io.swagger.codegen.languages.CSharpClientCodegen
    For more information, please visit [https://github.com/uJhin](https://github.com/uJhin)

<a name="frameworks-supported"></a>
## Frameworks supported
- .NET 4.0 or later
- Windows Phone 7.1 (Mango)

<a name="dependencies"></a>
## Dependencies
- [RestSharp](https://www.nuget.org/packages/RestSharp) - 105.1.0 or later
- [Json.NET](https://www.nuget.org/packages/Newtonsoft.Json/) - 7.0.0 or later
- [JsonSubTypes](https://www.nuget.org/packages/JsonSubTypes/) - 1.2.0 or later

The DLLs included in the package may not be the latest version. We recommend using [NuGet](https://docs.nuget.org/consume/installing-nuget) to obtain the latest version of the packages:
```
Install-Package RestSharp
Install-Package Newtonsoft.Json
Install-Package JsonSubTypes
```

NOTE: RestSharp versions greater than 105.1.0 have a bug which causes file uploads to fail. See [RestSharp#742](https://github.com/restsharp/RestSharp/issues/742)

<a name="installation"></a>
## Installation
Run the following command to generate the DLL
- [Mac/Linux] `/bin/sh build.sh`
- [Windows] `build.bat`

Then include the DLL (under the `bin` folder) in the C# project, and use the namespaces:
```csharp
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;
```
<a name="packaging"></a>
## Packaging

A `.nuspec` is included with the project. You can follow the Nuget quickstart to [create](https://docs.microsoft.com/en-us/nuget/quickstart/create-and-publish-a-package#create-the-package) and [publish](https://docs.microsoft.com/en-us/nuget/quickstart/create-and-publish-a-package#publish-the-package) packages.

This `.nuspec` uses placeholders from the `.csproj`, so build the `.csproj` directly:

```
nuget pack -Build -OutputDirectory out IO.Swagger.csproj
```

Then, publish to a [local feed](https://docs.microsoft.com/en-us/nuget/hosting-packages/local-feeds) or [other host](https://docs.microsoft.com/en-us/nuget/hosting-packages/overview) and consume the new package via Nuget as usual.

<a name="getting-started"></a>
## Getting Started

```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class Example
    {
        public void main()
        {

            // Configure API key authorization: Bearer
            Configuration.Default.ApiKey.Add("Authorization", "YOUR_API_KEY");
            // Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
            // Configuration.Default.ApiKeyPrefix.Add("Authorization", "Bearer");

            var apiInstance = new APIKeyApi();

            try
            {
                // API 키 리스트 조회
                List<APIKey> result = apiInstance.APIKeyInfo();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling APIKeyApi.APIKeyInfo: " + e.Message );
            }

        }
    }
}
```

<a name="documentation-for-api-endpoints"></a>
## Documentation for API Endpoints

All URIs are relative to *https://api.upbit.com/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*APIKeyApi* | [**APIKeyInfo**](docs/APIKeyApi.md#apikeyinfo) | **GET** /api_keys | API 키 리스트 조회
*AccountApi* | [**AccountInfo**](docs/AccountApi.md#accountinfo) | **GET** /accounts | 전체 계좌 조회
*AccountApi* | [**AccountWallet**](docs/AccountApi.md#accountwallet) | **GET** /status/wallet | 입출금 현황
*CandleApi* | [**CandleDays**](docs/CandleApi.md#candledays) | **GET** /candles/days | 시세 캔들 조회 (일 단위)
*CandleApi* | [**CandleMinutes**](docs/CandleApi.md#candleminutes) | **GET** /candles/minutes/{unit} | 시세 캔들 조회 (분 단위)
*CandleApi* | [**CandleMonth**](docs/CandleApi.md#candlemonth) | **GET** /candles/months | 시세 캔들 조회 (월 단위)
*CandleApi* | [**CandleWeeks**](docs/CandleApi.md#candleweeks) | **GET** /candles/weeks | 시세 캔들 조회 (주 단위)
*DepositApi* | [**DepositCoinAddress**](docs/DepositApi.md#depositcoinaddress) | **GET** /deposits/coin_address | 개별 입금 주소 조회
*DepositApi* | [**DepositCoinAddresses**](docs/DepositApi.md#depositcoinaddresses) | **GET** /deposits/coin_addresses | 전체 입금 주소 조회
*DepositApi* | [**DepositGenerateCoinAddress**](docs/DepositApi.md#depositgeneratecoinaddress) | **POST** /deposits/generate_coin_address | 입금 주소 생성 요청
*DepositApi* | [**DepositInfo**](docs/DepositApi.md#depositinfo) | **GET** /deposit | 개별 입금 조회
*DepositApi* | [**DepositInfoAll**](docs/DepositApi.md#depositinfoall) | **GET** /deposits | 입금 리스트 조회
*MarketApi* | [**MarketInfoAll**](docs/MarketApi.md#marketinfoall) | **GET** /market/all | 마켓 코드 조회
*OrderApi* | [**OrderCancel**](docs/OrderApi.md#ordercancel) | **DELETE** /order | 주문 취소 접수
*OrderApi* | [**OrderChance**](docs/OrderApi.md#orderchance) | **GET** /orders/chance | 주문 가능 정보
*OrderApi* | [**OrderInfo**](docs/OrderApi.md#orderinfo) | **GET** /order | 개별 주문 조회
*OrderApi* | [**OrderInfoAll**](docs/OrderApi.md#orderinfoall) | **GET** /orders | 주문 리스트 조회
*OrderApi* | [**OrderNew**](docs/OrderApi.md#ordernew) | **POST** /orders | 주문하기
*OrderApi* | [**OrderOrderbook**](docs/OrderApi.md#orderorderbook) | **GET** /orderbook | 시세 호가 정보(Orderbook) 조회
*TradeApi* | [**TradeTicker**](docs/TradeApi.md#tradeticker) | **GET** /ticker | 시세 Ticker 조회
*TradeApi* | [**TradeTicks**](docs/TradeApi.md#tradeticks) | **GET** /trades/ticks | 시세 체결 조회
*WithdrawApi* | [**WithdrawChance**](docs/WithdrawApi.md#withdrawchance) | **GET** /withdraws/chance | 출금 가능 정보
*WithdrawApi* | [**WithdrawCoin**](docs/WithdrawApi.md#withdrawcoin) | **POST** /withdraws/coin | 코인 출금하기
*WithdrawApi* | [**WithdrawInfo**](docs/WithdrawApi.md#withdrawinfo) | **GET** /withdraw | 개별 출금 조회
*WithdrawApi* | [**WithdrawInfoAll**](docs/WithdrawApi.md#withdrawinfoall) | **GET** /withdraws | 출금 리스트 조회
*WithdrawApi* | [**WithdrawKrw**](docs/WithdrawApi.md#withdrawkrw) | **POST** /withdraws/krw | 원화 출금하기


<a name="documentation-for-models"></a>
## Documentation for Models

 - [Model.APIKey](docs/APIKey.md)
 - [Model.Account](docs/Account.md)
 - [Model.Ask](docs/Ask.md)
 - [Model.AskAccount](docs/AskAccount.md)
 - [Model.Bid](docs/Bid.md)
 - [Model.BidAccount](docs/BidAccount.md)
 - [Model.CandleDate](docs/CandleDate.md)
 - [Model.CandleDays](docs/CandleDays.md)
 - [Model.CandleMinutes](docs/CandleMinutes.md)
 - [Model.Currency](docs/Currency.md)
 - [Model.Deposit](docs/Deposit.md)
 - [Model.DepositCompleteResponse](docs/DepositCompleteResponse.md)
 - [Model.DepositTransferResponse](docs/DepositTransferResponse.md)
 - [Model.Error](docs/Error.md)
 - [Model.ErrorInfo](docs/ErrorInfo.md)
 - [Model.Market](docs/Market.md)
 - [Model.MarketInfo](docs/MarketInfo.md)
 - [Model.MemberLevel](docs/MemberLevel.md)
 - [Model.NewOrder](docs/NewOrder.md)
 - [Model.Order](docs/Order.md)
 - [Model.OrderChance](docs/OrderChance.md)
 - [Model.OrderInfo](docs/OrderInfo.md)
 - [Model.Orderbook](docs/Orderbook.md)
 - [Model.OrderbookUnit](docs/OrderbookUnit.md)
 - [Model.Ticker](docs/Ticker.md)
 - [Model.Trade](docs/Trade.md)
 - [Model.TradeTicks](docs/TradeTicks.md)
 - [Model.Wallet](docs/Wallet.md)
 - [Model.Withdraw](docs/Withdraw.md)
 - [Model.WithdrawChance](docs/WithdrawChance.md)
 - [Model.WithdrawCoin](docs/WithdrawCoin.md)
 - [Model.WithdrawLimit](docs/WithdrawLimit.md)


<a name="documentation-for-authorization"></a>
## Documentation for Authorization

<a name="Bearer"></a>
### Bearer

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header

